//+------------------------------------------------------------------+
//|                                                    My Expert.mq4 |
//|                                       Copyright  2006, Rahim10. |
//|                                                                  |
//+------------------------------------------------------------------+



extern double PercentRisk=0.03;
extern int PivotHourStart = 7;
extern int TPLevel=10;
extern bool P_M3_Long = true;
extern bool P_M2_Long = true;

extern bool P_M3_Short = false;
extern bool P_M2_Short = false;

extern bool TrailingStopOn = true;
extern double TrailingStopKickIn = 2;
extern double TrailingStopKickInShort = 1;




static int DayPivotsPrintedFlag;
static int DayOpenPriceLocFlag;
static int DayTradeExecFlag;
static double LotPositionSize;
static double TrailStopSize;
static int ticket;
static double yesterday_high, yesterday_low, yesterday_close, today_open;

int init()
  {

   DayPivotsPrintedFlag = DayOfWeek();
   DayOpenPriceLocFlag = DayOfWeek();
   DayTradeExecFlag = DayOfWeek();
   ticket = 0;
   
   yesterday_close=iClose(NULL,PERIOD_D1,1);
   today_open=iOpen(NULL,PERIOD_D1,0);
   yesterday_high=iHigh(NULL,PERIOD_D1,1);
   yesterday_low=iLow(NULL,PERIOD_D1,1);
   

   return(0);
  }


int deinit()
  {

   return(0);
  }





int start()
  {
   
   double P, R1, R2, S1, S2, M1, M2, M3, M4;
   
   
   if (OrdersTotal() > 0 && TrailingStopOn) {  
      

//   for (int k=0;k <= OrdersTotal();k++) {      
      
      OrderSelect(ticket,SELECT_BY_TICKET);
      
      if (OrderType() == OP_BUY && (Ask - OrderOpenPrice()) > TrailStopSize*TrailingStopKickIn && OrderStopLoss() < (Ask-TrailStopSize)) {

         OrderModify(OrderTicket(),OrderOpenPrice(),Ask - TrailStopSize,OrderTakeProfit(),0,Green);
           }
     
      if (OrderType() == OP_SELL && (OrderOpenPrice() - Bid) > TrailStopSize*TrailingStopKickInShort && OrderStopLoss() > (Bid + TrailStopSize)) {

         OrderModify(OrderTicket(),OrderOpenPrice(),Bid + TrailStopSize,OrderTakeProfit(),0,Red);
           }
//      }

 } 






   if (TimeHour(TimeCurrent())== PivotHourStart && TimeMinute(TimeCurrent())==1) {
   
      yesterday_close=iClose(NULL,PERIOD_M1,2);
      today_open=iOpen(NULL,PERIOD_M1,0);    
      
      yesterday_high=0;
      for(int i=0;i<=1440;i++){
      if (iHigh(NULL,PERIOD_M1,i) > yesterday_high) yesterday_high = iHigh(NULL,PERIOD_M1,i);
      } 
      
      yesterday_low=100;
      for(int j=0;j<=1440;j++) {
        if (iLow(NULL,PERIOD_M1,j) < yesterday_low) yesterday_low = iLow(NULL,PERIOD_M1,j); 
      }   
      
      
      Print("High:",yesterday_high," Low:",yesterday_low," Close:",yesterday_close," Open:",today_open);
   
      ObjectCreate(StringConcatenate(TimeCurrent(),""),OBJ_VLINE,0,TimeCurrent(),1);      
      
      
            P = (yesterday_high + yesterday_low + yesterday_close) / 3;
      
            ObjectCreate(StringConcatenate("P   ",TimeCurrent()),2,0,TimeCurrent(),P,TimeCurrent()+86400,P);
            ObjectSet(StringConcatenate("P   ",TimeCurrent()),OBJPROP_COLOR,Chartreuse);
            ObjectSet(StringConcatenate("P   ",TimeCurrent()),OBJPROP_RAY,false); 
            
            R1 = 2*P - yesterday_low;
            
            ObjectCreate(StringConcatenate("R1   ",TimeCurrent()),2,0,TimeCurrent(),R1,TimeCurrent()+86400,R1);
            ObjectSet(StringConcatenate("R1   ",TimeCurrent()),OBJPROP_COLOR,Yellow);
            ObjectSet(StringConcatenate("R1   ",TimeCurrent()),OBJPROP_RAY,false);
            
            S1 = 2*P - yesterday_high;
            
            ObjectCreate(StringConcatenate("S1   ",TimeCurrent()),2,0,TimeCurrent(),S1,TimeCurrent()+86400,S1);
            ObjectSet(StringConcatenate("S1   ",TimeCurrent()),OBJPROP_COLOR,Yellow);
            ObjectSet(StringConcatenate("S1   ",TimeCurrent()),OBJPROP_RAY,false);
            
            M2 = (P + R1)/2;
            
            ObjectCreate(StringConcatenate("M2   ",TimeCurrent()),2,0,TimeCurrent(),M2,TimeCurrent()+86400,M2);
            ObjectSet(StringConcatenate("M2   ",TimeCurrent()),OBJPROP_RAY,false);
            
            M3 = (P + S1)/2;
            
            ObjectCreate(StringConcatenate("M3   ",TimeCurrent()),2,0,TimeCurrent(),M3,TimeCurrent()+86400,M3);
            ObjectSet(StringConcatenate("M3   ",TimeCurrent()),OBJPROP_RAY,false);

            
   
   }  
   

           
      
      P = (yesterday_high + yesterday_low + yesterday_close) / 3;
      R1 = 2*P - yesterday_low;
      S1 = 2*P - yesterday_high;
      R2 = (P - S1) + R1;
      S2 = P - (R1 - S1);
      M1 = (R1 + R2)/2;
      M2 = (P + R1)/2;
      M3 = (P + S1)/2;
      M4 = (S1 + S2)/2;     

   
   

         
         
             

    


//*********************************************************P TO M3****************************************************




  if(DayTradeExecFlag != DayOfWeek() && today_open < P && today_open > M3)
      {     
      
      
            //Long Trade

         if (Ask > M2+2*Point && (M2-P)*(1/Point)>9 && (M2-P)*(1/Point)<19 && Ask < (M2+0.5*(M2-P)) && P_M3_Long) {  
         
            LotPositionSize=(MathRound(((AccountBalance()*PercentRisk)/((M2-P)))/10000))/10;
         
            ticket=OrderSend(Symbol(),OP_BUY,LotPositionSize,Ask,3,Ask-(M2-P),Ask+10*(M2-P),"",16384,0,Green);
            
            TrailStopSize = (M2-P);
            Print("Buy at ",Ask,"  Ticket:",ticket," Stop Size:",TrailStopSize);
      
            Print("Position Size:",   (MathRound(   ((AccountBalance()*PercentRisk)/((M2-P)))/10000  ))/10     ,"    ",(AccountBalance()*0.03)/(M2-P));
            
            ObjectCreate(StringConcatenate("Ticket: ",ticket," Open"),2,0,TimeCurrent()-160,today_open,TimeCurrent()+160,today_open);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_COLOR,White);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_RAY,false);             
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_WIDTH,2); 
          
            DayTradeExecFlag=DayOfWeek(); }  
            

 
            //Short Trade


        if (Bid < S1-2*Point && (M3-S1)*(1/Point)>9 && (M3-S1)*(1/Point)<19 && P_M3_Short) { 
         
            
            LotPositionSize=(MathRound(((AccountBalance()*0.03)/(M3-S1))/10000))/10;        
            
            ticket=OrderSend(Symbol(),OP_SELL,LotPositionSize,Bid,3,Bid+(M3-S1),Bid-4*(M3-S1),"",16384,0,Red);
            
            TrailStopSize = (M3-S1);
            
            Print("Sell at ",Bid,"  Ticket:",ticket," Stop Size:",TrailStopSize," Time:",iTime(Symbol(),1440,0));
            
            Print("Position Size:",   (MathRound(   ((AccountBalance()*0.03)/(M3-S1))/10000  ))/10     ,"   ",(AccountBalance()*0.03)/(M3-S1));
            
            DayTradeExecFlag=DayOfWeek(); }          
            
      }  


//********************************************************P TO M3*********************************************************



//*******************************************************P TO M2**********************************************************

 if(DayTradeExecFlag != DayOfWeek() && today_open > (P+(M2-P)*0.2) && today_open < (M2-(M2-P)*0.2))
      {     

               //Long Trade 
   
         if (Ask > R1+2*Point && (R1-M2)*(1/Point)>9 && (R1-M2)*(1/Point)<19 && Ask<(R1+0.5*(R1-M2)) && P_M2_Long) {  
         
            LotPositionSize=(MathRound(((AccountBalance()*PercentRisk)/((R1-M2)))/10000))/10;
         
            ticket=OrderSend(Symbol(),OP_BUY,LotPositionSize,Ask,3,Ask-(R1-M2),Ask+10*(R1-M2),"",16384,0,Green);
            
            TrailStopSize = (R1-M2);
            Print("Buy at ",Ask,"  Ticket:",ticket," Stop Size:",TrailStopSize);
      
            Print("Position Size:",   (MathRound(   ((AccountBalance()*PercentRisk)/((R1-M2)))/10000  ))/10     ,"    ",(AccountBalance()*0.03)/(R1-M2));
            
            ObjectCreate(StringConcatenate("Ticket: ",ticket," Open"),2,0,TimeCurrent()-160,today_open,TimeCurrent()+160,today_open);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_COLOR,White);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_RAY,false);             
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_WIDTH,2); 
                 
            DayTradeExecFlag=DayOfWeek(); }    
            

               //Short Trade


         if (Bid < M3-2*Point && (P-M3)*(1/Point)>9 && (P-M3)*(1/Point)<19 && Bid>(M3-0.5*(P-M3)) && P_M2_Short) { 
         
            
            LotPositionSize=(MathRound(((AccountBalance()*0.03)/(P-M3))/10000))/10;        
            
            ticket=OrderSend(Symbol(),OP_SELL,LotPositionSize,Bid,3,Bid+(P-M3),Bid-TPLevel*(P-M3),"",16384,0,Red);
            
            TrailStopSize = (P-M3);
            
            Print("Sell at ",Bid,"  Ticket:",ticket," Stop Size:",TrailStopSize," Time:",iTime(Symbol(),1440,0));
            
            Print("Position Size:",   (MathRound(   ((AccountBalance()*0.03)/(P-M3))/10000  ))/10     ,"   ",(AccountBalance()*0.03)/(P-M3));
          
            ObjectCreate(StringConcatenate("Ticket: ",ticket," Open"),2,0,TimeCurrent()-160,today_open,TimeCurrent()+160,today_open);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_COLOR,White);
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_RAY,false);             
            ObjectSet(StringConcatenate("Ticket: ",ticket," Open"),OBJPROP_WIDTH,2); 
            
            DayTradeExecFlag=DayOfWeek(); }       
            
     
     
     }



//************************************************************ P TO M2******************************************************
   
       
   return(0);
}




